#!/bin/sh
#
# orpheus.sh by Stefan Tomanek <stefan.tomanek@wertarbyte.de>
#              http://wertarbyte.de/tartarus.shtml
#
# This script pulls single files from the backup archives
# It uses list files generated by tartarus to find the archive
# containing the most recent version of a file
#
# WARNING This is still highly experimental!

CONFIG=$1
REQUEST=$2

. $CONFIG

awk -vREQUEST="$REQUEST" '
    substr($11,2) == REQUEST {
        n=split(FILENAME, T, "/");
        LIST=T[n]
        ARCHIVE=LIST;
        sub("\\.list$", "", ARCHIVE)
        print ARCHIVE, substr($11,2);
    }' "${FILE_LIST_DIRECTORY}"/tartarus-*.list | \
    sort -r | \
    while read ARCHIVE FILENAME; do
        echo "Restoring $FILENAME from $ARCHIVE" >&2
        # FIXME&TODO Detect archive format, encryption and compression
        curl -s -u ${STORAGE_FTP_USER}:${STORAGE_FTP_PASSWORD} --ftp-ssl -k ftp://${STORAGE_FTP_SERVER}/${ARCHIVE} | \
        gpg --decrypt | \
        afio -v -P bzip2 -Z -y "$REQUEST" -i -
    done
